#ifndef GAME_H_INCLUDED
#define GAME_H_INCLUDED

#include "stuff.h"
#include <vector>
using namespace std;

class Game {

    static const int playerSpeed = 10;

    Bitmap titleMask, titlePat;
    Bitmap background, island;
    Bitmap buffer;

    int combo, comboTimer;
    int totalHit;
    int playerx, playery;
    vector<int> islandx;
    vector<int> islandy;
    vector<int32_t> islandrot;
    void drawIslands();
    bool touchesPlayer(int ix, int iy);
    void handleLogic();

    vector<string> log;
    void logMessage(string msg);
    void drawLog();

    double fps;
    int frames;
    long lasttime;
    void calculateFPS();

    bool closed();
    void pixelMove(Bitmap& from, Bitmap& to);
    void drawScene();

public:

    Game();

    bool loadres();
    int title();
    int play();
};

inline bool Game::closed() {
    return ::close_button_pressed;
}

inline void Game::pixelMove(Bitmap& from, Bitmap& to) {
    stretch_blit(from.ptr(), to.ptr(), 0, 0, from->w, from->h, 0, 0, to->w, to->h);
}

#endif // GAME_H_INCLUDED
