#ifndef MYALLEG_SAMPLE_H_INCLUDED
#define MYALLEG_SAMPLE_H_INCLUDED

#include "stuff.h"

class Sample {
    SAMPLE* snd;
    bool willfree;
    void free() { stop(); if(snd != NULL && willfree) destroy_sample(snd); snd = NULL; willfree = false; }
public:
    Sample() : snd(NULL), willfree(false) { }
    Sample(SAMPLE* sample) : snd(sample), willfree(false) { }
    Sample(string filename) : snd(NULL), willfree(false) { load(filename); }
    ~Sample() { free(); }

    bool load(string filename) {
        free(); willfree = true;
        return (snd = load_sample(filename.c_str())) != NULL;
    }

    void play(int volume = 128, int pan = 128, int freq = 1000) { play_sample(snd, volume, pan, freq, 0); }
    void loop(int volume = 128, int pan = 128, int freq = 1000) { play_sample(snd, volume, pan, freq, 1); }
    void adjust(int volume, int pan, int freq) { adjust_sample(snd, volume, pan, freq, 1); }
    void stop() { stop_sample(snd); }

    SAMPLE* ptr() { return snd; }
    SAMPLE* operator->() { return ptr(); }
};

#endif // SAMPLE_H_INCLUDED
